//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "cpmain.h"
#include "rpt1.h"
#include "netprev.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmCustPrevMain *frmCustPrevMain;
//---------------------------------------------------------------------------
__fastcall TfrmCustPrevMain::TfrmCustPrevMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmCustPrevMain::btnPreviewClick(TObject *Sender)
{
  // We use a common OnPreview event defined in this form.  This allows
  // to set this event for any report.
  if (UseCustomPreviewCbo->Checked) {
    frmRpt1->QuickRep1->OnPreview = CustomPreview;
  }
  else {
    frmRpt1->QuickRep1->OnPreview = NULL;
  }

  frmRpt1->QuickRep1->Preview();
  Application->ProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TfrmCustPrevMain::CustomPreview(TObject *Sender)
{
  TfrmNetPrev* PrevForm = new TfrmNetPrev(this);

  // Set the options for the preview
  if (cbStayOnTop->Checked) {
    PrevForm->WindowState = wsMaximized;
    PrevForm->FormStyle = fsStayOnTop;
  }
  PrevForm->PrintPreviewImage = RenderOnceCbo->Enabled;
  PrevForm->btnPrint->Enabled = cbAllowPrinting->Checked;
  PrevForm->UpdateButtons();

  // Pass in the report's QRPrinter object to the preview
  PrevForm->QRPreview1->QRPrinter = dynamic_cast<TQRPrinter*>(Sender);

  // Set the caption
  PrevForm->Caption = "preview - " + PrevForm->QRPreview1->QRPrinter->Title;

  // Display the preview.  You must use Show(), if you use ShowModal() the
  // code that processes the report will not get called.
  PrevForm->Show();

  // Do not call "delete PrevForm", this is a modeless preview form.
  // When the form is closed, it's close action is caFree, which will
  // free the object automaticly

}
//---------------------------------------------------------------------------

void __fastcall TfrmCustPrevMain::FormCreate(TObject *Sender)
{
  // Create a global object to contain custom preview options.  This
  // code is not used by the demo, but you could use it to create an
  // object to contain global preview settings
  PreviewOptions = new TPreviewOptions(TRUE);
}
//---------------------------------------------------------------------------

void __fastcall TfrmCustPrevMain::FormDestroy(TObject *Sender)
{
  delete PreviewOptions;
}
//---------------------------------------------------------------------------

void __fastcall TfrmCustPrevMain::UseCustomPreviewCboClick(TObject *Sender)
{
  cbAllowPrinting->Enabled = UseCustomPreviewCbo->Checked;
  cbStayOnTop->Enabled = UseCustomPreviewCbo->Checked;
  RenderOnceCbo->Enabled = UseCustomPreviewCbo->Checked;
}
//---------------------------------------------------------------------------

