//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "netprev.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmNetPrev *frmNetPrev;
TPreviewOptions *PreviewOptions;

//---------------------------------------------------------------------------
// This class is not currently used, it is included to show a method
// of defining a class that would hold global preview options.
TPreviewOptions::TPreviewOptions()
{
  AllowPrint = TRUE;
}

TPreviewOptions::TPreviewOptions(bool _AllowPrint)
{
  AllowPrint = _AllowPrint;
}
//---------------------------------------------------------------------------
void __fastcall TfrmNetPrev::FormCreate(TObject *Sender)
{
  // initialize the variables
  PrintPreviewImage = FALSE;
}
//---------------------------------------------------------------------------
__fastcall TfrmNetPrev::TfrmNetPrev(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmNetPrev::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmNetPrev::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  // Tell the QRPrinter to signal the report that it can free the
  // QRPrinter object assigned to the report.  Without this line,
  // the QRPrinter object will not be freed.
  QRPreview1->QRPrinter->ClosePreview(this);

  // Free the preview form
  Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TfrmNetPrev::btnPrintClick(TObject *Sender)
{
  // If you set the QRPrinter->Master property to NULL, the report will
  // not render the report again when you print, it will just copy the
  // metafiles used by the preview to the printer.
  if (PrintPreviewImage) {
    QRPreview1->QRPrinter->Master = NULL;
  }
  QRPreview1->QRPrinter->Print();
}
//---------------------------------------------------------------------------
void __fastcall TfrmNetPrev::btnZoomInClick(TObject *Sender)
{
  Application->ProcessMessages();
  QRPreview1->Zoom += 10;
}
//---------------------------------------------------------------------------
void __fastcall TfrmNetPrev::btnZoomOutClick(TObject *Sender)
{
  Application->ProcessMessages();
  QRPreview1->Zoom -= 10;
}
//---------------------------------------------------------------------------
void __fastcall TfrmNetPrev::btnOpenClick(TObject *Sender)
{
  // Here's how to load a saved report
  if (OpenDialog1->Execute()) {
    QRPreview1->QRPrinter->Load(OpenDialog1->FileName);
    QRPreview1->PageNumber = 1;
    QRPreview1->PreviewImage->PageNumber = 1;
    Caption = "preview - " + OpenDialog1->FileName;
  }
}
//---------------------------------------------------------------------------
void __fastcall TfrmNetPrev::UpdateButtons(void)
{
  AnsiString nameString("TButton");
  TButton * button;
  int NextLeft = btnPrint->Left;

  // Line the enabled controls and hide the disabled ones
  for (int i=0; i < ComponentCount; i++) {
    if (Components[i]->ClassNameIs(nameString)) {
      //cast the component to a TButton *
      button = (TButton *)Components[i];

      button->Visible = button->Enabled;

      if (button->Enabled) {
        button->Left = NextLeft;
        NextLeft = NextLeft + button->Width;
      }
    }
  }
}

// The following code does not work.  It's based on the Delphi code for
// registering a preview interface.
Controls::TWinControl* __fastcall TQRNetPrevInterface::Show(TQRPrinter* AQRPrinter)
{
  TfrmNetPrev* PrevForm = new TfrmNetPrev(this);

  PrevForm->QRPreview1->QRPrinter = AQRPrinter;

  PrevForm->Show();

  return (PrevForm);
}
Controls::TWinControl* __fastcall TQRNetPrevInterface::ShowModal(TQRPrinter* AQRPrinter)
{
  TfrmNetPrev* PrevForm = new TfrmNetPrev(this);

  PrevForm->QRPreview1->QRPrinter = AQRPrinter;

  PrevForm->Show();

  return (PrevForm);
}
void __fastcall NetPrev(void)
{
  TQRNetPrevInterface* tmpInstance = new TQRNetPrevInterface(NULL);

  RegisterPreviewClass(__classid(TQRNetPrevInterface));

  delete tmpInstance;
}
//---------------------------------------------------------------------------
